
Program Browse;

(* WinShell 3.00 unit sample test : SHBrowseForFolder

   By Alcatiz (www.lpjjl.net) for vpascal.com - 2008 *)

Uses Strings,
     WinCRT,
     Windows,
     WinShell;

Var BrowseInfo : tBrowseInfo;
    ItemIdList : pItemIdList;
    Memory : IMalloc;
    c : pChar;
    DlgTitle : Array [0..79] of Char;

Begin
  InitWinCRT;
  WriteLn(#10#13'WinShell 3.00 sample test');
  WriteLn('-------------------------');
  Write('Please choose a folder in the following dialog... (Press Enter) ');
  ReadLn;
  if SHGetMalloc(@Memory) = NOERROR
     then
       begin
         c := Memory.Alloc(MAX_PATH);
         if c <> Nil
            then
              begin
                FillChar(BrowseInfo,SizeOf(BrowseInfo),0);
                BrowseInfo.hWndOwner := GetFocus;
                BrowseInfo.pidlRoot := Nil;
                BrowseInfo.pszDisplayName := c;
                StrCopy(DlgTitle,'Please choose a folder');
                BrowseInfo.lpszTitle := DlgTitle;
                ItemIdList := SHBrowseForFolder(@BrowseInfo);
                if ItemIdList <> Nil
                   then
                     begin
                       SHGetPathFromIdList(ItemIdList,c);
                       Writeln('---> ',c);
                       Memory.Free(ItemIdList);
                     end
                   else
                     WriteLn('SHBrowseForFolder error !');
                Memory.Free(c);
              end
            else
              WriteLn('IMalloc.Alloc error !');
       end
     else
       WriteLn('SHGetMalloc error !');
  Write(#10#13'(Press Enter) ');
  ReadLn;
  DoneWinCRT;
End.

