
Program LinkPath;

(* WinShell 3.00 unit sample test : retrieve the work path of a shortcut.

   By Alcatiz (www.lpjjl.net) for vpascal.com - 2008 *)

Uses Strings,
     CRT,
     Windows,
     WinShell;

Var c : Array [0..MAX_PATH] of Char;    (* Ansi path *)
    w : Array [0..MAX_PATH] of WChar;   (* Unicode path *)
    HRes : hResult;
    ShellLink : IShellLink;
    PersistFile : IPersistFile;
    szPath : Array [0..MAX_PATH] of Char;
    Win32FindData : tWin32FindData;

Begin
  Write('Initialize COM library (CoInitialize) : ');
  HRes := CoInitialize(Nil);
  if HRes = s_OK
     then
       begin
         WriteLn('OK');
         Write('   Create an IShellLink interface instance (CoCreateInstance) : ');
         HRes := CoCreateInstance(CLSID_ShellLink,Nil,CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER,IID_IShellLink,ShellLink);
         if HRes = s_OK
            then
              begin
                WriteLn('OK');
                Write('      Initialize IPersistFile interface (IPersistFile.QueryInterface) : ');
                HRes := ShellLink.QueryInterface(IID_IPersistFile,PersistFile);
                if HRes = s_OK
                   then
                     begin
                       Writeln('OK');
                       Write('         Load link file (IPersistFile.Load) : ');
                       StrCopy(c,'C:\Documents and Settings\admin\Desktop\Virtual Pascal.lnk');
                       MultiByteToWideChar(CP_ACP,0,c,-1,@w,SizeOf(w));
                       HRes := PersistFile.Load(@w,STGM_READWRITE);
                       if HRes = s_OK
                            then
                              begin
                                WriteLn('OK');
                                Write('            Read the path (IShellLink.GetPath) : ');
                                HRes := ShellLink.GetPath(szPath,SizeOf(szPath),Win32FindData,SLGP_RAWPATH);
                                if HRes = s_OK
                                   then
                                     begin
                                       WriteLn('OK');
                                       WriteLn('            ---> ',szPath);
                                     end
                                   else
                                     WriteLn('error');
                              end
                            else
                              WriteLn('error');
                       WriteLn('         Release IPersistFile interface (IPersistFile.Release)');
                       PersistFile.Release;
                     end
                   else
                     WriteLn('error');
                WriteLn('   Release IShellLink interface (IShellLink.Release)');
                ShellLink.Release;
              end
            else
              WriteLn('error');
         WriteLn('Free COM library (CoUninitialize)');
         CoUninitialize;
       end
     else
       WriteLn('error');
  ReadLn;
End.

